/** Prosta struktura danych posiadajca trzy waciwoci: pastwo,
 *  komentarz i plikFlagi. Wszystkie trzy s acuchami znakowymi 
 *  i su kolejno do reprezentowania pastwa, ktre posiada miasto
 *  lub prowincj o nazwie "Java", komentarza precyzujcego 
 *  pooenie miejscowo wewntrz tego pastwa oraz ciek 
 *  wskazujc plik graficzny zawierajcy flag pastwa.
 *  Klasa ta jest wykorzystywana w przykadach ilustrujcych 
 *  niestandardowe modele danych i wywietlacze komrek dla 
 *  kontrolki JList.
 *
 *  Kody zaczerpniete z polskiej edycji
 *  ksiazki Serwisy internetowe. Programowanie
 *  Wydawnictwo Helion, Gliwice,
 *  ftp://ftp.helion.pl/przyklady/serinp.zip
 *  &copy; 2001 Marty Hall and Larry Brown;
 */

public class MiejscowoscJava {
  private String panstwo, komentarz, plikFlagi;

  public MiejscowoscJava(String panstwo, String komentarz,
                      String plikFlagi) {
    ustawPanstwo(panstwo);
    ustawKomentarz(komentarz);
    ustawPlikFlagi(plikFlagi);
  }

  /** Reprezentacja tekstowa uywana na wydrukach i w kontrolce JList */
  
  public String toString() {
    return("Java, " + podajPanstwo() + " (" + podajKomentarz() + ").");
  }
  
  /** Zwraca pastwo posiadajce miasto lub prowincj o nazwie "Java". */
  
  public String podajPanstwo() {
    return(panstwo);
  }

  /** Pozwala okreli pastwo posiadajce miasto lub prowincj o nazwie "Java". */
  
  public void ustawPanstwo(String panstwo) {
    this.panstwo = panstwo;
  }

  /** Zwraca komentarz na temat miasta lub prowincji o nazwie "Java".
   *  Najczcie w postaci "blisko takiego a takiego miasta".
   */
  
  public String podajKomentarz() {
    return(komentarz);
  }

  /** Pozwala okreli komentarz na temat miasta lub prowincji o nazwie "Java".. */

  public void ustawKomentarz(String komentarz) {
    this.komentarz = komentarz;
  }
  
  /** Zwraca ciek do pliku z rysunkiem flagi pastwowej. */
  
  public String podajPlikFlagi() {
    return(plikFlagi);
  }

  /** Pozwala okreli ciek do pliku z rysunkiem flagi pastwowej. */
  
  public void ustawPlikFlagi(String plikFlagi) {
    this.plikFlagi = plikFlagi;
  }
}