import java.rmi.*;
import java.net.*;

/** Tworzy obiekt typu ZdalnaCalkaImpl i rejestruje go pod nazw
 *  'ZdalnaCalka' dziki czemu klienci mog si z nim czy
 *  celem wykonania cakowania numerycznego. Serwer ten powinien
 *  zosta umieszczony na stacji roboczej szybko wykonujcej obliczenia 
 *  zmiennopozycyjne, podczas gdy wolniejszy interfejs uytkownika moe by
 *  uruchamiany na mniejszych komputerach ale moe korzysta z procedur
 *  cakowania.
 *
 *  Kody zaczerpniete z polskiej edycji
 *  ksiazki Serwisy internetowe. Programowanie
 *  Wydawnictwo Helion, Gliwice,
 *  ftp://ftp.helion.pl/przyklady/serinp.zip
 *  &copy; 2001 Marty Hall and Larry Brown;
 */

public class SerwerZdalnaCalka {
  public static void main(String[] args) {
    try {
      ZdalnaCalkaImpl calka =  new ZdalnaCalkaImpl();
      Naming.rebind("rmi:///ZdalnaCalka", calka);
    } catch(RemoteException re) {
      System.out.println("RemoteException: " + re);
    } catch(MalformedURLException mfe) {
      System.out.println("MalformedURLException: " + mfe);
    }
  }
}